#include <ArduinoJson.h>
#include <DallasTemperature.h>
#include <ESP8266WiFi.h>          //https://github.com/esp8266/Arduino
#include <PubSubClient.h>
#include <DNSServer.h>
#include <ESP8266WebServer.h>
#include <WiFiManager.h>          //https://github.com/tzapu/WiFiManager
#include <OneWire.h>
#include <FS.h>   //Include File System Headers
#include <TimeLib.h>
#include <NtpClientLib.h>
#include "Adafruit_LEDBackpack.h"
#include "Adafruit_GFX.h"
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>


#ifndef STASSID
#define STASSID "UniFi-Messstelle"
#define STAPSK  "Coam24611@meins.de"
#define OTAHOST  "Pool-Thermometer-TEST"
#endif
String cssstyle = "";


#define VERSION "9.3";
const char* ssid = STASSID;
const char* password = STAPSK;
const char* otahostname = OTAHOST;


unsigned long ss = 0;                 // current second since startup


#define DISPLAY_ADDRESS   0x70
Adafruit_7segment clockDisplay = Adafruit_7segment();

ESP8266WebServer server(80);
int ajaxIntervall = 2;
float temperatur;

String Beschreibung = "Wemos D1";
String screentime = "5000";
String onewireintervall = "5000";
String ntpserver = "pool.ntp.org";
String mqtthost;
String mqttport;
String mqttclient;
String mqttuser;
String mqttpass;
String mqttactive;
String mqttmessage = "getrennt";

bool mqtt = false;
bool save = false;

char mqttb[50];

// 4 Display
String temp;
char char1;
char char2;
char char3;
char char4;
bool blinkColon = false;
int screen = 0;
String letztemessung = "";
String webString;
int neuehelligkeit = 10;
  byte i;
  byte addr[8];

// NTP
int8_t timeZone = 1;
int8_t minutesTimeZone = 0;
bool wifiFirstConnected = true;
String yearntp,monthntp,datentp,hourntp,minutentp,secondsntp,dayntp; //declaring all vars as String Type.
boolean syncEventTriggered = false; // True if a time even has been triggered
NTPSyncEvent_t ntpEvent; // Last triggered event


//MQTT
const char* mqtt_server = "192.168.xxx.xxx"; //66 fhem
char lasttemperatur[6] = "00.00";
WiFiClient espClient;
PubSubClient client(espClient);
int nummerror = 0;
String mqtttopica = "";
String mqtttopicb = "";
String mqtttopicc = "";
char charmqtttopica[50];
char charmqtttopicb[50];
char charmqtttopicc[50];
char charmqttuser[50];
char charmqttpass[50];
long lastReconnectAttempt = 0;


int DS18S20_Pin = 12; //DS18S20 Signal pin on digital 5
int deviceCount = 0;
DeviceAddress Thermometer;


//Temperature chip i/o
OneWire OneWire(DS18S20_Pin);  // on digital pin 2
DallasTemperature sensors(&OneWire);



struct Config {
  char Beschreibungn[64];
  char screentimen[64];
  char onewireintervalln[64];
  char ntpservern[64];
  char mqtthostn[64];
  char portn[64];
  char mqttclientn[64];
  char mqttusern[64];  
  char mqttpassn[64];
  char mqttactiven[64];    
};


const char *filename = "/config.json";  // <- SD library uses 8.3 filenames
Config config;                         // <- global configuration object

void configModeCallback (WiFiManager *myWiFiManager) {
  Serial.println("Entered config mode");
  Serial.println(WiFi.softAPIP());
  Serial.print("Created config portal AP ");
  Serial.println(myWiFiManager->getConfigPortalSSID());
  clockDisplay.begin(DISPLAY_ADDRESS);
  clockDisplay.clear();
  clockDisplay.drawColon(false);
  clockDisplay.writeDigitRaw(0,64);
  clockDisplay.writeDigitRaw(1,119);
  clockDisplay.writeDigitRaw(3,115);
  clockDisplay.writeDigitRaw(4,64);
  clockDisplay.writeDisplay();
  Serial.println("Display AP on LCD");
}

void setup() {
  int i = 0;
  Serial.begin(115200);
  
  if(SPIFFS.begin())
  {
    Serial.println("SPIFFS Initialisierung....OK");
  }
  else
  {
    Serial.println("SPIFFS Initialisierung...Fehler!");
  }

  // Should load default config if run for the first time
  Serial.println(F("Loading configuration..."));
  loadConfiguration(filename, config);

//deleteConfiguration(filename, config);

   
  WiFiManager wifiManager;
  wifiManager.setAPCallback(configModeCallback);

  if(!wifiManager.autoConnect("AutoConnectAP")) {
    Serial.println("failed to connect and hit timeout");
    ESP.reset();
    delay(1000);
  } 

  //if you get here you have connected to the WiFi
createcssstyle();
  wifiFirstConnected = true;
    server.on("/", handle_Status);
    server.on("/setup.html", handle_Setup);
    server.on("/action_page", handle_Form); //form action is handled here
    server.on("/restart.html", handle_Restart); //form action is handled here
    server.on("/werk1.html", handle_Werk1); //form action is handled here
    server.on("/werk2.html", handle_Werk2); //form action is handled here
    server.on("/info.html", handle_Info); //form action is handled here
    server.on("/c.php", handleCommand);   // process commands
    server.on("/j.js", handleJs); // a javascript to handle AJAX/JSON Update of the page
    server.on("/json", handleJson); // send data in JSON

    server.onNotFound(handle_NotFound);
    server.begin();
  Serial.println("HTTP Server gestartet");


  ArduinoOTA.setHostname(otahostname);
  ArduinoOTA.onStart([]() {
    String type;
    if (ArduinoOTA.getCommand() == U_FLASH) {
      type = "sketch";
    } else { // U_SPIFFS
      type = "filesystem";
    }

    // NOTE: if updating SPIFFS this would be the place to unmount SPIFFS using SPIFFS.end()
    Serial.println("Start updating " + type);
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\nEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) {
      Serial.println("Auth Failed");
    } else if (error == OTA_BEGIN_ERROR) {
      Serial.println("Begin Failed");
    } else if (error == OTA_CONNECT_ERROR) {
      Serial.println("Connect Failed");
    } else if (error == OTA_RECEIVE_ERROR) {
      Serial.println("Receive Failed");
    } else if (error == OTA_END_ERROR) {
      Serial.println("End Failed");
    }
  });
  ArduinoOTA.begin();


sensors.begin();
Serial.println ("Suche 1-Wire Sensoren");
Serial.println ("==================================================");
  Serial.print("Found ");
  deviceCount = sensors.getDeviceCount();
  Serial.print(deviceCount, DEC);
  Serial.println(" devices.");
  Serial.println("");

  for (int i = 0;  i < deviceCount;  i++)
  {
    Serial.print("Sensor ");
    Serial.print(i+1);
    Serial.print(" : ");
    sensors.getAddress(Thermometer, i);
    printAddress(Thermometer);
  sensors.requestTemperatures();
  float tempC = sensors.getTempC(Thermometer);
  Serial.print(" | ");
  Serial.print(tempC);
  Serial.print("°");
  Serial.println("C");  
  }
Serial.println ("==================================================");

  


  
    NTP.onNTPSyncEvent ([](NTPSyncEvent_t event) {
        ntpEvent = event;
        syncEventTriggered = true;
    });
clockDisplay.begin(DISPLAY_ADDRESS);
        clockDisplay.setBrightness(neuehelligkeit);
        clockDisplay.clear();
        clockDisplay.writeDisplay();
        Serial.print ("Setze Helligkeit auf (0-15): '");
        Serial.print (neuehelligkeit);
        Serial.println ("'");
        

  if (mqtt) {
  strcpy(mqttb, mqtthost.c_str());
  client.setServer(mqttb,mqttport.toInt());
  client.setCallback(mqttCallback);
  }

  
}
void createcssstyle() {
cssstyle = "";
  
cssstyle = "<style type='text/css'>";
cssstyle +="table { border-collapse: collapse; }";
cssstyle +="td { overflow:hidden; vertical-align:top; font-family:Arial; font-size:20px; color:#ffffff; padding: 5px 5px 5px 5px}";
cssstyle +=".myButton { box-shadow: 0px 10px 14px -7px #276873; background:linear-gradient(to bottom, #1FA3EC 5%, #1FA3EC 100%); background-color:#f50505; border-radius:8px; display:inline-block; cursor:pointer; color:#ffffff; font-family:Arial; font-size:20px; font-weight:bold; padding:13px 50px; text-decoration:none; text-shadow:0px 1px 0px #3d768a; width:350px}";
cssstyle +=".myButton:hover { background:linear-gradient(to bottom, #0E70A4 5%, #0E70A4 100%); background-color:#994075 }";
cssstyle +=".myButton:active { position:relative; top:1px }";
cssstyle +=".myButtonRed { box-shadow: 0px 10px 14px -7px #276873; background:linear-gradient(to bottom, #D43535 5%, #D43535 100%); background-color:#f50505; border-radius:8px; display:inline-block; cursor:pointer; color:#ffffff; font-family:Arial; font-size:20px; font-weight:bold; padding:13px 50px; text-decoration:none; text-shadow:0px 1px 0px #3d768a; width:350px}";
cssstyle +=".myButtonRed:hover { background:linear-gradient(to bottom, #931F1F 5%, #931F1F 100%); background-color:#994075}";
cssstyle +=".myButtonRed:active { position:relative; top:1px}";
cssstyle +=".myButtonGreen { box-shadow: 0px 10px 14px -7px #276873; background:linear-gradient(to bottom, #47C266 5%, #47C266 100%); background-color:#f50505; border-radius:8px; display:inline-block; cursor:pointer; color:#ffffff; font-family:Arial; font-size:20px; font-weight:bold; padding:13px 50px; text-decoration:none; text-shadow:0px 1px 0px #3d768a; width:450px }";
cssstyle +=".myButtonGreen:hover { background:linear-gradient(to bottom, #5AAF6F 5%, #5AAF6F 100%); background-color:#994075}";
cssstyle +=".myButtonGreen:active { position:relative; top:1px}";
cssstyle +=".slider { -webkit-appearance: none; width: 450px; height: 25px; background: #d3d3d3; outline: none; opacity: 0.7; transition: opacity .2s}";
cssstyle +=".slider:hover { opacity: 1 }";
cssstyle +=".slider::-webkit-slider-thumb {-webkit-appearance: none;appearance: none;width: 25px;height: 50px;background: #888;cursor: pointer }";
cssstyle +=".slider::-moz-range-thumb {width: 25px; height: 50px; background: #888; cursor: pointer}";
cssstyle +="footer p{font-size:0.7em;color:white;background:#000000;text-align:center;margin-bottom:5px;width:450px}";
cssstyle +="input[type=text]:focus { background-color: lightblue}";
cssstyle +="input[type=text], select {width: 100%; padding: 5px 5px; margin: 5px 0; display: inline-block; border: 1px solid #ccc; border-radius: 4px; box-sizing: border-box; font-size: 21px}";
cssstyle +="</style>";
Serial.println ("CSS-String erstellt...");
}

void processSyncEvent (NTPSyncEvent_t ntpEvent) {
    if (ntpEvent) {
        Serial.print ("Time Sync Fehler: ");
        if (ntpEvent == noResponse)
            Serial.println ("NTP-Server nicht erreichbar");
        else if (ntpEvent == invalidAddress)
            Serial.println ("falsche NTP-Server Addresse");
    } else {
        Serial.print ("habe NTP-Zeit erhalten: ");
        Serial.println (NTP.getTimeDateString (NTP.getLastNTPSync ()));
    }
}





void loop() {


  
  static long last = 0;
  static long lastb = 0;
  static long lastc = 0;
  static long i = 0;
  char MsgTemp[6];

  ss = millis() / 1000;
    
      if (wifiFirstConnected) {
        wifiFirstConnected = false;

        ntpserver.trim();
        NTP.begin (ntpserver, timeZone, true, minutesTimeZone);
        NTP.setInterval (63);
        Serial.print ("Hole aktuelle Zeit von : '");
        Serial.print (ntpserver);
        Serial.println ("'...");
    }

    if (syncEventTriggered) {
        processSyncEvent (ntpEvent);
        syncEventTriggered = false;
    }

    if ((millis () - lastb) > 1000) {
        lastb = millis ();
        blinkColon =! blinkColon;
        i++;
                if (i >= 3600) { wifiFirstConnected = true; i = 0;}
                
        if (screen == 1) {Display_Time(); }
    }

    if ((millis () - lastc) > screentime.toInt()) {
        lastc = millis ();
        
            if (screen == 1) {
                                screen = 0;
                                Display_Temp();
                              } else
                            {
                              screen = 1;
                              Display_Time();
                             }
       }

     
    if ((millis () - last) > onewireintervall.toInt()) {
        last = millis ();

        
        sensors.requestTemperatures();
        temperatur = sensors.getTempCByIndex(0);
        

        if (temperatur < -20 || temperatur > 60) {
          Serial.print("Messfehler ! Temp <-20 ooder > 60 ! Gemessen : ");
          Serial.print(temperatur);
        } else
        {
        hourntp   = String(NTP.getTimeDateString ()).substring(0,2);
        minutentp = String(NTP.getTimeDateString ()).substring(3,5);
        secondsntp = String(NTP.getTimeDateString ()).substring(6,8);
        datentp   = String(NTP.getTimeDateString ()).substring(9,11);
        monthntp  = String(NTP.getTimeDateString ()).substring(12,14);
        yearntp   = String(NTP.getTimeDateString ()).substring(15,19);
        letztemessung = String(hourntp)+":"+String(minutentp)+":"+String(secondsntp)+" "+String(datentp)+"."+String(monthntp)+"."+String(yearntp);


dtostrf(temperatur, 4, 1, MsgTemp);
//  letztemessung = String(datentp)+"."+String(monthntp)+"."+String(yearntp)+" "+String(hourntp)+":"+String(minutentp);

if (mqtt) {
  
if(strcmp(lasttemperatur, MsgTemp) != 0) {


char copy[20];
letztemessung.toCharArray(copy, 20);
   Serial.print(copy);
   Serial.print("  an MQTT gesendet : '");
   Serial.print(MsgTemp);
   Serial.println("'");

   client.publish(charmqtttopicb, MsgTemp);
   client.publish(charmqtttopicc, copy);
   memcpy(lasttemperatur, MsgTemp, sizeof(MsgTemp));
  }
  else {
   Serial.print(letztemessung);
   Serial.print("  Nicht an MQTT gesendet : '");
   Serial.print(MsgTemp);
   Serial.println("' (gleiche Temperatur)");
  }
  }
  else {
    char copy[20];
letztemessung.toCharArray(copy, 20);
  }
}
    }
server.handleClient();


  if (!client.connected() && mqtt ) {
    long now = millis();
    mqttmessage = "getrennt";
    if (now - lastReconnectAttempt > 5000) {
      lastReconnectAttempt = now;
      // Attempt to reconnect
      if (reconnect()) {
        lastReconnectAttempt = 0;
      }
    }
  } else {
    mqttmessage = "verbunden";
  }
  client.loop();
  yield();
ArduinoOTA.handle();
}


void loadConfiguration(const char *filename, Config &config) {
  // Open file for reading
  File file = SPIFFS.open(filename, "r");

  // Allocate a temporary JsonDocument
  // Don't forget to change the capacity to match your requirements.
  // Use arduinojson.org/v6/assistant to compute the capacity.
  StaticJsonDocument<1024> doc;

  // Deserialize the JSON document
  DeserializationError error = deserializeJson(doc, file);
  if (error)
    Serial.println(F("Failed to read file, using default configuration"));

  // Copy values from the JsonDocument to the Config

  
strlcpy(config.Beschreibungn,                  // <- destination
          doc["Beschreibungn"] | "Wemos D1",  // <- source
          sizeof(config.Beschreibungn));         // <- destination's capacity


strlcpy(config.screentimen,                  // <- destination
          doc["screentimen"] | "5000",  // <- source
          sizeof(config.screentimen));         // <- destination's capacity
          
strlcpy(config.onewireintervalln,                  // <- destination
          doc["onewireintervalln"] | "5000",  // <- source
          sizeof(config.onewireintervalln));         // <- destination's capacity
          

  strlcpy(config.ntpservern,                  // <- destination
          doc["ntpservern"] | "",  // <- source
          sizeof(config.ntpservern));         // <- destination's capacity

          
  strlcpy(config.mqtthostn,                  // <- destination
          doc["mqtthostn"] | "",  // <- source
          sizeof(config.mqtthostn));         // <- destination's capacity

   strlcpy(config.portn,                  // <- destination
          doc["portn"] | "1883",  // <- source
          sizeof(config.portn));         // <- destination's capacity
         
  strlcpy(config.mqttclientn,                  // <- destination
          doc["mqttclientn"] | "",  // <- source
          sizeof(config.mqttclientn));         // <- destination's capacity
          

            strlcpy(config.mqttusern,                  // <- destination
          doc["mqttusern"] | "",  // <- source
          sizeof(config.mqttusern));         // <- destination's capacity  
            

  strlcpy(config.mqttpassn,                  // <- destination
          doc["mqttpassn"] | "",  // <- source
          sizeof(config.mqttpassn));         // <- destination's capacity

  strlcpy(config.mqttactiven,                  // <- destination
          doc["mqttactiven"] | "",  // <- source
          sizeof(config.mqttactiven));         // <- destination's capacity

  file.close();

Beschreibung = config.Beschreibungn;
ntpserver = config.ntpservern;
mqtthost = config.mqtthostn;
mqttport = config.portn;
mqttclient = config.mqttclientn;
mqttuser = config.mqttusern;
mqttpass = config.mqttpassn;
screentime = config.screentimen;
onewireintervall = config.onewireintervalln;

      mqttclient.trim();
      mqtttopica = "/" + mqttclient + "/Set/Helligkeit";
      mqtttopicb = "/" + mqttclient + "/Get/Temperatur";
      mqtttopicc = "/" + mqttclient + "/Get/last";

  
mqtttopica.toCharArray(charmqtttopica, 50);
mqtttopicb.toCharArray(charmqtttopicb, 50);
mqtttopicc.toCharArray(charmqtttopicc, 50);

mqttuser.toCharArray(charmqttuser, 50);
mqttpass.toCharArray(charmqttpass, 50);


if (screentime.toInt() > 2000000) { screentime = "2000000"; }
if (screentime.toInt() < 1) { screentime = "1"; }


if (onewireintervall.toInt() > 2000000) { onewireintervall = "2000000"; }
if (onewireintervall.toInt() < 1) { onewireintervall = "1"; }
      
if (strcmp(config.mqttactiven, "ON") == 0) { 
  mqtt = true;
} else
{
 mqtt = false;
}  


  
}

// Saves the configuration to a file
void saveConfiguration(const char *filename, const Config &config) {
  // Delete existing file, otherwise the configuration is appended to the file

  // Open file for writing
  File file = SPIFFS.open(filename, "w");
  if (!file) {
    Serial.println(F("Failed to create file"));
    save = false;
    return;
  }

  // Allocate a temporary JsonDocument
  // Don't forget to change the capacity to match your requirements.
  // Use arduinojson.org/assistant to compute the capacity.
  StaticJsonDocument<1024> doc;

  // Set the values in the document
  doc["Beschreibungn"] = Beschreibung;
  doc["screentimen"] = screentime;
  doc["onewireintervalln"] = onewireintervall;
  doc["ntpservern"] = ntpserver;
  doc["mqtthostn"] = mqtthost;
  doc["portn"] = mqttport;
  doc["mqttclientn"] = mqttclient;
  doc["mqttusern"] = mqttuser;
  doc["mqttpassn"] = mqttpass;
  doc["mqttactiven"] = mqttactive;
   


  // Serialize JSON to file
  if (serializeJson(doc, file) == 0) {
    Serial.println(F("Failed to write to file"));
    save = false;
  }

  // Close the file
  file.close();
  Serial.println(F("gespeichert..."));
  save = true;
}


void deleteConfiguration(const char *filename, const Config &config) {

 Beschreibung = "Wemos D1";
 screentime = "5000";
 onewireintervall = "5000";
 ntpserver = "pool.ntp.org";
 mqtthost = "";
 mqttport = "";
 mqttclient = "";
 mqttuser = "";
 mqttpass = "";
 mqttactive ="";
 
  // Delete existing file, otherwise the configuration is appended to the file

  // Open file for writing
  File file = SPIFFS.open(filename, "w");
  if (!file) {
    Serial.println(F("Failed to create file"));
    save = false;
    return;
  }

  // Allocate a temporary JsonDocument
  // Don't forget to change the capacity to match your requirements.
  // Use arduinojson.org/assistant to compute the capacity.
  StaticJsonDocument<1024> doc;

  // Set the values in the document
  doc["Beschreibungn"] = Beschreibung;
  doc["screentimen"] = screentime;
  doc["onewireintervalln"] = onewireintervall;
  doc["ntpservern"] = ntpserver;
  doc["mqtthostn"] = mqtthost;
  doc["portn"] = mqttport;
  doc["mqttclientn"] = mqttclient;
  doc["mqttusern"] = mqttuser;
  doc["mqttpassn"] = mqttpass;
  doc["mqttactiven"] = mqttactive;
   


  // Serialize JSON to file
  if (serializeJson(doc, file) == 0) {
    Serial.println(F("Failed to write to file"));
    save = false;
  }

  // Close the file
  save = true;
  file.close();
}


// Prints the content of a file to the Serial
void printFile(const char *filename) {
  // Open file for reading
  File file = SPIFFS.open(filename, "r");  
  if (!file) {
    Serial.println(F("Failed to read file"));
    save = false;
    return;
  }

  // Extract each characters by one by one
  while (file.available()) {
    Serial.print((char)file.read());
  }
  Serial.println();

  // Close the file
  file.close();
  save = true;
  return;
}



boolean reconnect() {
Serial.print("Baue MQTT-Verbindung auf...");
  if (client.connect(config.mqttclientn)) {
    // Once connected, publish an announcement...
      client.publish(charmqtttopicb, "");
      client.publish(charmqtttopicc, "");
//      client.publish(charmqtttopicc, "10");
    // ... and resubscribe
    client.subscribe(charmqtttopica);
    client.subscribe(charmqtttopicb);
    client.subscribe(charmqtttopica);    
    Serial.println(" verbunden.");
  }
  else
  {
    Serial.println(" fehlgeschlagen.");

  }
  return client.connected();
}



void mqttCallback(char* topic, byte* payload, unsigned int length) {
    // message received
    
 // int neuehelligkeit = 0;
    Serial.print("erhaltende Nachricht [");
    Serial.print(topic);
    Serial.print("] ");
    char msg[length+1];
    for (int i = 0; i < length; i++) {
        Serial.print((char)payload[i]);
        msg[i] = (char)payload[i];
    }
    Serial.println();

if(strcmp(topic, charmqtttopica )==0){
  neuehelligkeit = atoi(msg);
  if (neuehelligkeit < 0) {
    neuehelligkeit = 0;
  }
    if (neuehelligkeit > 15) {
    neuehelligkeit = 15;
  }
        clockDisplay.setBrightness(neuehelligkeit);
        clockDisplay.writeDisplay();
        Serial.print ("Setze Helligkeit auf (0-15): '");
        Serial.print (neuehelligkeit);
        Serial.println ("'");
    }
    
    msg[length] = '\0';

}






void handleJs() {
// Output: a JavaScript
// a function in the JavaScript uses AJAX to request a JSON file from the webserver and updates the values on the page if the object names and ID are the same
String message;
message += F(" function GetSwitchState(s) {\n" // 0 call function with settimeout, 1 run only once for manual update
             " nocache = '&nocache='+ Math.random() * 1000000;\n"
             " var request = new XMLHttpRequest(); \n"
             " request.onreadystatechange = function() {\n"
             " if (this.readyState == 4) {\n"
             " if (this.status == 200) {\n"
             " if (this.responseText != null) {\n"
             " var jo=JSON.parse(this.responseText);\n"
             " for (var i in jo)\n"
             " {if(document.getElementById(i)) document.getElementById(i).innerHTML=jo[i];}\n" // as long as the JSON name fits to the HTML ID value will be replaced
             // add other fields here
             " document.getElementById('sec').innerHTML = Math.floor(jo['ss']%60);\n" // example how to change a value in the HTML page
             " if (jo['ss']>60){document.getElementById('min').innerHTML=Math.floor(jo['ss']/60%60);}\n"
             " if (jo['ss']>3600){document.getElementById('hour').innerHTML=Math.floor(jo['ss']/3600%24);}\n"
             " if (jo['ss']>86400){document.getElementById('day').innerHTML=Math.floor(jo['ss']/86400%7);}\n"
             " if (jo['ss']>604800){document.getElementById('week').innerHTML=Math.floor(jo['ss']/604800%52);}\n");
message += F(" document.getElementById('sec').style.color = 'white';\n"
             " }}}\n"
             " else {document.getElementById('sec').style.color = 'dimgray';}\n"
             " }\n"
             " request.open('GET', 'json?p="); // request the JSON output
message += server.uri();
message += F("' + nocache, true);\n"
             " request.send(null);\n"
             " if (s==0) setTimeout('GetSwitchState(0)', ");
message += ajaxIntervall * 1000;
message += F(");\n"
               "}\n\n");

  //for the slider interaction we use JavaScript to fire the event to the server
  message += F("function fire(c,v){\n"                                 // c channel (mostly the id/self) | v myValue
               " var request = new XMLHttpRequest();\n"
               " request.open('GET', 'c.php?'+c+'='+v, true);\n"
               " request.send(null);\n"
               " GetSwitchState(1);\n"   // after some actions the ajax should be called to update the page
               "}\n");

               
//server.send(200, "text/plain", message);
  server.send(200, "application/javascript", message);

}



void handleJson() {
// Output: send data to browser as JSON
// after modification always check if JSON is still valid. Just call the JSON (json) in your webbrowser and check.
// Serial.println(F("D230 requested json"));
String message = "";
message = (F("{\"ss\":")); // Start of JSON and the first object "ss":
message += millis() / 1000;
message += (F(",\"internalVcc\":"));
message += temperatur;
message += (F(",\"internalVcd\":"));
message += neuehelligkeit;
message += (F(",\"range1\":"));
message += neuehelligkeit;
message += (F(",\"mqttstatus\":"));
if (client.connected()) {
  mqttmessage = "1";
  message += mqttmessage;
}
else
{
  mqttmessage = "0";
  message += mqttmessage;
}
message += (F("}")); // End of JSON
server.send(200, "text/plain", message);
}


void printAddress(DeviceAddress deviceAddress)
{ 
  for (uint8_t i = 0; i < 8; i++)
  {
    Serial.print("0x");
    if (deviceAddress[i] < 0x10) Serial.print("0");
    Serial.print(deviceAddress[i], HEX);
    if (i < 7) Serial.print(", ");
  }
}
